typedef unsigned int DATA_LCD;

//-----------------------------------------------------------------------------
//shift resister
#define LCD_DATA_PORT					P5OUT
#define LCD_DATA_DDR					P5DIR
#define LCD_DATA_INIT()					LCD_DATA_DDR = 0xFF

#define LCD_WR_BIT						BIT2
#define LCD_DATA_WRON()					Sbi(P1OUT, LCD_WR_BIT)
#define LCD_DATA_WROFF()				Cbi(P1OUT, LCD_WR_BIT)
#define LCD_WR_INIT()					Sbi(P1DIR, LCD_WR_BIT);LCD_DATA_WRON()

#define LCD_RD_BIT						BIT7
#define LCD_DATA_RDON()					Sbi(P4OUT, LCD_RD_BIT)
#define LCD_DATA_RDOFF()				Cbi(P4OUT, LCD_RD_BIT)
#define LCD_RD_INIT()					Sbi(P4DIR, LCD_RD_BIT);LCD_DATA_RDON()

#define LCD_RE_BIT						BIT6
#define LCD_DATA_REON()					Sbi(P4OUT, LCD_RE_BIT)
#define LCD_DATA_REOFF()				Cbi(P4OUT, LCD_RE_BIT)
#define LCD_RE_INIT()					Sbi(P4DIR, LCD_RE_BIT);LCD_DATA_REON()

#define LCD_CS1_BIT						BIT5
#define LCD_DATA_CS1ON()				Sbi(P4OUT, LCD_CS1_BIT)
#define LCD_DATA_CS1OFF()				Cbi(P4OUT, LCD_CS1_BIT)
#define LCD_CS1_INIT()					Sbi(P4DIR, LCD_CS1_BIT);LCD_DATA_CS1ON()


#define LCD_LDATA_ON()					Sbi(P4OUT, BIT4)
#define LCD_LDATA_OFF()					Cbi(P4OUT, BIT4)
#define LCD_HDATA_ON()					Sbi(P4OUT, BIT3)
#define LCD_HDATA_OFF()					Cbi(P4OUT, BIT3)

#define LCD_LDATA_LATCH()				LCD_LDATA_ON();LCD_LDATA_OFF()
#define LCD_HDATA_LATCH()				LCD_HDATA_ON();LCD_HDATA_OFF()
#define LCD_DATA_LATCH_INIT()			Sbi(P4DIR, BIT4);Sbi(P4DIR, BIT3);LCD_HDATA_OFF();LCD_LDATA_OFF()


void OutData(unsigned int Data)
{
	LCD_DATA_PORT = Data&0xFF;
	LCD_LDATA_LATCH();
	
	LCD_DATA_PORT = (Data>>8)&0xFF;
	LCD_HDATA_LATCH();	
}

void OutControl(unsigned char Data)
{
	LCD_DATA_PORT = Data;
	LCD_LDATA_LATCH();
}


void clcd_init_hal(void)
{
	LCD_DATA_INIT();
	LCD_WR_INIT();
	LCD_RD_INIT();
	LCD_RE_INIT();
	LCD_CS1_INIT();
	LCD_DATA_LATCH_INIT();
}



//-----------------------------------------------------------------------------
